<template>
  <div class="btn-group btn-group-actions btn-group-xs">
    <a
      v-b-tooltip.hover.top="{ variant: 'dark' }"
      class="btn btn-link link-secondary btn-icon"
      :class="hideActionClass('switch')"
      title="Switch between possibles values"
      @click="switchEnumParam"
    >
      <SwitchHorizontalIcon class="icon-xxs" />
    </a>
    <a
      v-b-tooltip.hover.top="{ variant: 'dark' }"
      class="btn btn-link link-secondary btn-icon text-blue"
      :class="hideActionClass('reset')"
      title="Reset to default"
      @click="resetParam"
    >
      <RefreshIcon class="icon-xxs" />
    </a>
    <a
      v-b-tooltip.hover.top="{ variant: 'dark' }"
      class="btn btn-link link-secondary btn-icon text-blue"
      :class="hideActionClass('clear')"
      title="Clear value"
      @click="clearParam"
    >
      <ClearFormattingIcon class="icon-xxs" />
    </a>
    <a
      v-if="parameter.description"
      v-b-tooltip.hover.top="{ variant: 'dark' }"
      class="btn btn-link link-secondary btn-icon text-green cursor-default"
      :title="parameter.description || ''"
    >
      <InfoCircleIcon class="icon-xxs" />
    </a>
    <a href="#" class="btn btn-link link-secondary btn-icon disabled">
      <DotsVerticalIcon class="icon-xxs" />
    </a>
  </div>
</template>

<script>
const hideActionTable = {
  reset: {
    'string+dataset-id': true,
    'string+dataset-file-id': true,
    set: true,
  },
  clear: {
    'string+dataset-id': true,
    'string+dataset-file-id': true,
    set: true,
  },
};

const showActionTable = {
  switch: {
    'string+select': true,
  },
};

export default {
  props: {
    parameter: {
      type: Object,
      default: () => {},
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    updateValue: {
      type: Function,
      default: () => ({}),
    },
  },
  computed: {
    projectId() {
      return this.$nuxt.$route.params.id;
    },
    scenarioId() {
      return this.$nuxt.$route.params.scenarioId;
    },
    hideActionClass() {
      const type = this.parameter.type;
      return (action) => {
        const disabledClass = 'invisible disabled';
        if (showActionTable[action]) {
          if (showActionTable[action][type]) {
            return this.disabled ? 'disabled' : '';
          } else {
            return disabledClass;
          }
        }
        if (hideActionTable[action] && hideActionTable[action][type]) {
          return disabledClass;
        }
        return this.disabled ? 'disabled' : '';
      };
    },
  },
  methods: {
    switchEnumParam() {
      if (this.disabled) return;
      if (this.parameter.type === 'string+select') {
        this.$nuxt.context.store.dispatch('parameters/switchEnum', {
          projectId: this.projectId,
          scenarioId: this.scenarioId,
          key: this.parameter.key,
        });
      }
    },
    resetParam() {
      if (this.disabled) return;
      this.$nuxt.context.store.dispatch('parameters/reset', {
        projectId: this.projectId,
        scenarioId: this.scenarioId,
        key: this.parameter.key,
      });
    },
    async clearParam() {
      if (this.disabled) return;
      let newValue = '';
      if (this.parameter.type.toLowerCase() === 'range') {
        newValue = {
          min: '',
          max: '',
        };
      }
      await this.updateValue(this.parameter.key, newValue);
    },
  },
};
</script>
